#pragma once

class CHttpAsyncRequest
{
public:
	CHttpAsyncRequest() : m_hConnect(NULL), m_hRequest(NULL) {}

protected:
	HINTERNET			m_hConnect;	// WinHTTP̃RlNVnh
	HINTERNET			m_hRequest;	// WinHTTP̃NGXgnh
	std::stringstream	m_ssRead;	// ǂݍݍς݃f[^

public:
	BOOL IsConnected() const
	{
		return m_hConnect ? TRUE : FALSE;
	}
	void SendRequest( HINTERNET hSession,
					  const tstring& tstrUrl,
					  const tstring& tstrParameter,
					  BOOL bIsHttpVerbGet );
protected:
	virtual void Clear();
private:
	static void CALLBACK InternetCallback( HINTERNET hInternet,
										   DWORD_PTR dwContext,
										   DWORD dwInternetStatus,
										   LPVOID lpvStatusInformation,
										   DWORD dwStatusInformationLength);
	void OnCallback( DWORD dwInternetStatus,
					 LPVOID lpvStatusInformation,
					 DWORD dwStatusInformationLength );
	virtual void RequestSucceeded() = 0;
	virtual void RequestFailed( const tstring& tstrMessage ) = 0;
};
