// WinHttpAsyncRequestTest.cpp : AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"
#include "WinHttpAsyncRequestTest.h"

#include "HttpAsyncRequestCustom.h"

#define	STRING_URL1		_T("http://weather.livedoor.com/forecast/webservice/json/v1")
#define	STRING_PARAM1	_T("city=130010")
#define INT_VERB1		(0)

#define	STRING_URL2		_T("https://secure.nicovideo.jp/secure/login?site=nicolive_antenna")
#define	STRING_PARAM2	_T("mail=example@example.com&password=example")
#define INT_VERB2		(1)

#define URLBUFFER_SIZE		(4096)

INT_PTR CALLBACK DialogFunc( HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	// _CAOACenh
	static HWND s_hwndButtonSend0 = NULL;
	static HWND s_hwndButtonSend1 = NULL;
	static HWND s_hwndButtonSend2 = NULL;
	static HWND s_hwndEditUrl1 = NULL;
	static HWND s_hwndEditUrl2 = NULL;
	static HWND s_hwndEditParam1 = NULL;
	static HWND s_hwndEditParam2 = NULL;
	static HWND s_hwndComboVerb1 = NULL;
	static HWND s_hwndComboVerb2 = NULL;
	static HWND s_hwndEditResult1 = NULL;
	static HWND s_hwndEditResult2 = NULL;

	// ZbVnh
	static HINTERNET s_hSession = NULL;
	// NGXgnhIuWFNg
	static CHttpAsyncRequestCustom	m_htttrequest1;
	static CHttpAsyncRequestCustom	m_htttrequest2;

	// ėpϐ
	TCHAR tszUrl[URLBUFFER_SIZE] = _T("");
	TCHAR tszParam[URLBUFFER_SIZE] = _T("");
	int iCurSel = 0;

	switch( uMsg )
	{
	case WM_INITDIALOG:
		{
			s_hwndButtonSend0	= GetDlgItem( hwndDlg, IDC_BUTTON_SEND0 );
			s_hwndButtonSend1	= GetDlgItem( hwndDlg, IDC_BUTTON_SEND1 );
			s_hwndButtonSend2	= GetDlgItem( hwndDlg, IDC_BUTTON_SEND2 );
			s_hwndEditUrl1		= GetDlgItem( hwndDlg, IDC_EDIT_URL1 );
			s_hwndEditUrl2		= GetDlgItem( hwndDlg, IDC_EDIT_URL2 );
			s_hwndEditParam1	= GetDlgItem( hwndDlg, IDC_EDIT_PARAM1 );
			s_hwndEditParam2	= GetDlgItem( hwndDlg, IDC_EDIT_PARAM2 );
			s_hwndComboVerb1	= GetDlgItem( hwndDlg, IDC_COMBO_VERB1);
			s_hwndComboVerb2	= GetDlgItem( hwndDlg, IDC_COMBO_VERB2);
			s_hwndEditResult1	= GetDlgItem( hwndDlg, IDC_EDIT_RESULT1 );
			s_hwndEditResult2	= GetDlgItem( hwndDlg, IDC_EDIT_RESULT2 );

			SetWindowText( s_hwndEditUrl1, STRING_URL1 );
			SetWindowText( s_hwndEditUrl2, STRING_URL2 );

			SetWindowText( s_hwndEditParam1, STRING_PARAM1 );
			SetWindowText( s_hwndEditParam2, STRING_PARAM2 );

			SendMessage( s_hwndComboVerb1 , CB_ADDSTRING , 0 , (LPARAM)_T("GET") );
			SendMessage( s_hwndComboVerb1 , CB_ADDSTRING , 0 , (LPARAM)_T("POST") );
			SendMessage( s_hwndComboVerb1, CB_SETCURSEL, INT_VERB1, 0 );
			SendMessage( s_hwndComboVerb2 , CB_ADDSTRING , 0 , (LPARAM)_T("GET") );
			SendMessage( s_hwndComboVerb2 , CB_ADDSTRING , 0 , (LPARAM)_T("POST") );
			SendMessage( s_hwndComboVerb2, CB_SETCURSEL, INT_VERB2, 0 );

			// ZbVIuWFNg̍쐬
			WINHTTP_CURRENT_USER_IE_PROXY_CONFIG ieProxyConfig;
			ZeroMemory( &ieProxyConfig, sizeof(WINHTTP_CURRENT_USER_IE_PROXY_CONFIG) );
			WinHttpGetIEProxyConfigForCurrentUser( &ieProxyConfig );
			if( ieProxyConfig.lpszProxy )
			{	// InternetExplorer̃vLVŃZbVIuWFNg쐬
				s_hSession = WinHttpOpen( L"WinHttpAsyncTest",	// UserAgent 
										  WINHTTP_ACCESS_TYPE_NAMED_PROXY,	// vLVݒ
										  ieProxyConfig.lpszProxy,	// vLV
										  ieProxyConfig.lpszProxyBypass ? ieProxyConfig.lpszProxyBypass : WINHTTP_NO_PROXY_BYPASS,	// vLVoCpX
										  WINHTTP_FLAG_ASYNC);		// U镑IvVBWINHTTP_FLAG_ASYNĈݎw\B
			}
			else
			{
				s_hSession = WinHttpOpen( L"WinHttpAsyncTest",	// UserAgent 
										  WINHTTP_ACCESS_TYPE_DEFAULT_PROXY,	// vLVݒ
										  WINHTTP_NO_PROXY_NAME,	// vLV
										  WINHTTP_NO_PROXY_BYPASS,	// vLVoCpX
										  WINHTTP_FLAG_ASYNC);		// U镑IvVBWINHTTP_FLAG_ASYNĈݎw\B
			}
		}
		return TRUE;
	case WM_CLOSE:
		// ZbVnh̃N[Y
		WinHttpCloseHandle( s_hSession );

		EndDialog( hwndDlg, 0 );
		return TRUE;
	case WM_COMMAND:
		switch( LOWORD(wParam) )
		{
		case IDC_BUTTON_SEND0:
			SendMessage( hwndDlg, WM_COMMAND, IDC_BUTTON_SEND1, 0 );
			SendMessage( hwndDlg, WM_COMMAND, IDC_BUTTON_SEND2, 0 );
			return TRUE;
		case IDC_BUTTON_SEND1:
			// GfBbg{bNX̃Zbg
			SetWindowText( s_hwndEditResult1, _T("") );
			// GfBbg{bNX̎̕擾
			GetWindowText( s_hwndEditUrl1, tszUrl, URLBUFFER_SIZE );
			GetWindowText( s_hwndEditParam1, tszParam, URLBUFFER_SIZE );
			// R{{bNẌʒu̎擾
			iCurSel = (int)SendMessage( s_hwndComboVerb1, CB_GETCURSEL, 0, 0);

			// NGXgM
			m_htttrequest1.m_hwndDlg = hwndDlg;
			m_htttrequest1.m_iIDC_result = IDC_EDIT_RESULT1;		// DataGfBbg{bNX̃Rg[hc
			m_htttrequest1.SendRequest( s_hSession,
										tszUrl,
										tszParam,
										1 == iCurSel ? TRUE : FALSE );
			// M{^̖L̍XV
			PostMessage( hwndDlg, WM_USER_UPDATESENDBUTTON, 0, 0 );
			return TRUE;
		case IDC_BUTTON_SEND2:
			// GfBbg{bNX̃Zbg
			SetWindowText( s_hwndEditResult2, _T("") );
			// GfBbg{bNX̎̕擾
			GetWindowText( s_hwndEditUrl2, tszUrl, URLBUFFER_SIZE );
			GetWindowText( s_hwndEditParam2, tszParam, URLBUFFER_SIZE );
			// R{{bNẌʒu̎擾
			iCurSel = (int)SendMessage( s_hwndComboVerb2, CB_GETCURSEL, 0, 0);

			// NGXgM
			m_htttrequest2.m_hwndDlg = hwndDlg;
			m_htttrequest2.m_iIDC_result = IDC_EDIT_RESULT2;		// DataGfBbg{bNX̃Rg[hc
			m_htttrequest2.SendRequest( s_hSession,
										tszUrl,
										tszParam,
										1 == iCurSel ? TRUE : FALSE );
			// M{^̖L̍XV
			PostMessage( hwndDlg, WM_USER_UPDATESENDBUTTON, 0, 0 );
			return TRUE;
		}
		return FALSE;
	case WM_USER_UPDATESENDBUTTON:
		EnableWindow( s_hwndButtonSend0,
					  !m_htttrequest1.IsConnected() && !m_htttrequest2.IsConnected() );
		EnableWindow( s_hwndButtonSend1,
					  !m_htttrequest1.IsConnected() );
		EnableWindow( s_hwndButtonSend2,
					  !m_htttrequest2.IsConnected() );
		return TRUE;
	default:
		return FALSE;
	}
}

int APIENTRY _tWinMain( HINSTANCE hInstance,
						HINSTANCE hPrevInstance,
						LPTSTR lpCmdLine,
						int nCmdShow )
{
	DialogBox(	hInstance,
				MAKEINTRESOURCE(IDD_DIALOG1),
				HWND_DESKTOP,
				(DLGPROC)DialogFunc );

	return 0;
}



